/**
 * Creates a list of attributes from a given node, that can be visualized when the node is clicked
 * @param node The node from the graph which attributes need to be visualized
 */

import { NodeType } from '../Types';

export const useNLPopup = (node: NodeType) => {};
//   private createAttributes = (node: NodeType) => {
//     node.gfxAttributes = new PIXI.Graphics();
//     node.gfxAttributes.beginFill(0xeeeeee);
//     node.gfxAttributes.name = 'attributes_' + node.id;
//     node.gfxAttributes.alpha = 0;
//     node.gfxAttributes.eventMode = 'auto';
//     // add title
//     const gfxName = new PIXI.Text();
//     if (node.displayInfo != undefined) {
//       gfxName.text = node.displayInfo;
//     } else {
//       gfxName.text = node.id;
//     }
//     gfxName.style.fontSize = 16;
//     gfxName.style.fontFamily = 'Poppins, arial, sans-serif';
//     gfxName.style.fontWeight = 'bold';
//     gfxName.x = 10;
//     gfxName.y = 10;
//     gfxName.name = 'header';
//     node.gfxAttributes.addChild(gfxName);

//     // add attributes container
//     const container = new PIXI.Container();
//     node.gfxAttributes.addChild(container);
//     // add container for keys
//     const keys = new PIXI.Container();
//     container.addChild(keys);
//     // add container for values
//     const values = new PIXI.Container();
//     container.addChild(values);

//     // add attributes
//     if (node.attributes) {
//       let index = 0;
//       for (const key in node.attributes) {
//         const attributes = this.visibleAttributes[node?.label || node.id];
//         const attributeHidden = attributes ? attributes[key] === false : false;
//         if (attributeHidden) continue; // if attribute should be hidden, then skip
//         this.addAttribute(keys, values, key, String(node.attributes[key]), index);
//         index++;
//       }
//     }

//     // position attribute containers
//     container.x = 10;
//     container.y = 45;
//     values.x = keys.width + 10;

//     // calculate width
//     const width = this.calcAttrWidth(node.gfxAttributes) + 40;
//     const height = container.height + 55;
//     node.gfxAttributes.drawRoundedRect(0, 0, width, height, 10);

//     // add stripe
//     const gfxLine = new PIXI.Graphics();
//     gfxLine.beginFill(0xbbbbbb);
//     gfxLine.drawRect(10, 35, width - 20, 1);
//     node.gfxAttributes.addChild(gfxLine);

//     this.stage.addChild(node.gfxAttributes);
//   };

//   /**
//    * Helper function of createAttributes: adds an attribute to the new attributes graphic
//    */
//   private addAttribute(keys: PIXI.Container, values: PIXI.Container, key: string, value: string, index: number): void {
//     // add text for key
//     const keyText = new PIXI.Text();
//     keyText.style.fontSize = 14;
//     keyText.style.fontFamily = 'Poppins, arial, sans-serif';
//     keyText.style.fontWeight = 'bold';
//     keyText.name = 'key';
//     keyText.text = key + ':';
//     keyText.y = index * 20;
//     keys.addChild(keyText);
//     // add text for value
//     const valueText = new PIXI.Text();
//     valueText.style.fontSize = 14;
//     valueText.style.fontFamily = 'Poppins, arial, sans-serif';
//     valueText.name = 'value';
//     valueText.text = value;
//     valueText.y = index * 20;
//     values.addChild(valueText);
//   }

//   /**
//    * Helper function of createAttributes: calculates the width of the attributes graphic
//    */
//   private calcAttrWidth(gfxAttributes: PIXI.Graphics): number {
//     let width = 0;
//     gfxAttributes.children.forEach((child) => {
//       width = this.calcObjectWidth(child as PIXI.Text | PIXI.Graphics, width);
//     });

//     return width;
//   }

//   /**
//    * Helper function of calcAttrWidth: calculates the width of a child element of the attributes graphic
//    */
//   private calcObjectWidth(object: PIXI.Text | PIXI.Graphics, minWidth?: number): number {
//     const newWidth = object.width;
//     return minWidth ? Math.max(newWidth, minWidth) : newWidth;
// }

//   /**
//    * Calls for the Display that pops up and highlights the node and the links
//    * if ShortestPath turns on, it turns off the highlightedlinks!
//    * @param node The node clicked in the event
//    */
//   public ToggleInformationOnNode(node: NodeType) {
//     this.simulation.alphaTarget(0).restart(); // renderer will not always update without this line
//     this.showAttributes(node);
//     // this.highlightNode(node);
//     // this.highlightLinks(node);
//     // this.showShortestPath();
// }

//   /**
//    * When clicking on a node, toggle the select, making the text visible/invisible.
//    * @param node The node which text should be toggled.
//    */
//   public showAttributes = (node: NodeType) => {
//     if (node.selected) {
//       if (node.gfxAttributes) {
//         node.gfxAttributes.alpha = 0;
//         node.selected = false;
//       }
//     } else {
//       if (node.gfxAttributes) node.gfxAttributes.destroy();
//       this.createAttributes(node);
//       if (node.gfxAttributes) {
//         node.gfxAttributes.scale.x = 1 / this.scalexy + 0.001 * this.scalexy;
//         node.gfxAttributes.scale.y = 1 / this.scalexy + 0.001 * this.scalexy;
//         node.gfxAttributes.alpha = 1;
//         node.selected = true;
//       }
//     }
//   };

//   /**
//    * Refreshes the attributes. This function is called when the attribute filter has been changed
//    * @param graph the graph of which its nodes should be checked for attributes
//    */
//   const UpdateAttributes = (graph: GraphType) => {
//     this.simulation.alphaTarget(0).restart(); // required so that the visualization updates
//     graph.nodes.forEach((node: NodeType) => {
//       if (node.gfxAttributes !== undefined) {
//         // destroy and add the attributes pop-up again
//         node.gfxAttributes.destroy();
//         this.createAttributes(node);
//         node.gfxAttributes.scale.x = 1 / this.scalexy + 0.001 * this.scalexy;
//         node.gfxAttributes.scale.y = 1 / this.scalexy + 0.001 * this.scalexy;
//         // make the pop-up visible if it was visible before
//         if (node.selected) {
//           node.gfxAttributes.alpha = 1;
//         }
//       }
//     });
//   };
