/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { XYPosition } from 'reactflow';

/**
 * Calculates the difference between two positions.
 * @param {XYPosition} posA The first position.
 * @param {XYPosition} posB The second position.
 * @return {number} The distance between the first and second position.
 */
export function CalcDistance(posA: XYPosition, posB: XYPosition): number {
  const diffX = posA.x - posB.x;
  const diffY = posA.y - posB.y;

  return Math.sqrt(diffX * diffX + diffY * diffY);
}
